//+------------------------------------------------------------------+
//|                                           test_count_click_2.mq5 |
//|                                                2016, Dina Paches |
//|                           https://login.mql5.com/ru/users/dipach |
//+------------------------------------------------------------------+
#property copyright "2016, Dina Paches"
#property link      "https://login.mql5.com/ru/users/dipach"
#property version   "1.23"
#property indicator_chart_window
#property indicator_plots   0
//---
#include <ObjectCreateAndSet.mqh>
/*    .  :
https://www.mql5.com/ru/forum/63951/page2#comment_1908129*/
#define TEST_PRINT_ONE(x)          Print(__LINE__,", ",__FUNCTION__,", ",(#x)," = ",(x))
#define TEST_PRINT_TWO(x,y)        Print(__LINE__,", ",__FUNCTION__,", ",(#x)," = ",(x),", ",(#y)," = ",(y))
#define TEST_PRINT_THREE(x,y,z)    Print(__LINE__,", ",__FUNCTION__,", ",(#x)," = ",(x),", ",(#y)," = ",(y),", ",(#z)," = ",(z))
//---
#define NAME_INDICATOR             "count_click_2: "
#define QUANT_OBJ                  (6)// 
#define NUMBER_ALL                 ((QUANT_OBJ/2)-1)//    
#define X_DISTANCE                 (10) 
#define Y_DISTANCE                 (10)
#define WIDTH                      (60)
#define HEIGHT                     (20)
#define FONT_SIZE                  (9)
#define CLR_PANEL                  clrSilver//  
#define CLR_BORDER                 clrLavender// 
#define CORNER_PANEL               CORNER_RIGHT_UPPER
//---
int findPrefixObject,countClick[NUMBER_ALL+1],
flagAntivandal,flagResetEventDelete;
datetime timeCreateObj[QUANT_OBJ];
string prefixObj,textObj[QUANT_OBJ],nameObj[QUANT_OBJ],
textDelInd[2],textRestoring;
//---  :
color clrText[NUMBER_ALL+1]={clrDarkGreen,clrBrown,C'39,39,39'};
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
/* ,      , 
          
 :*/
   flagAntivandal=flagResetEventDelete=-1;
/*          
OnChartEvent():*/
   findPrefixObject=-1;
//---          :
   StringConcatenate(prefixObj,NAME_INDICATOR,Symbol(),"_",
                     EnumToString(Period()));
//---    :
   IndicatorSetString(INDICATOR_SHORTNAME,prefixObj);
//---   ,      :
   LanguageTerminal();
//---   : 
   NameObjectPanel(QUANT_OBJ,nameObj,prefixObj,"i");
//---        
   ArrayInitialize(countClick,0);
//---    :
   for(int i=NUMBER_ALL;i>=0;i--){textObj[i]="0";}
//---  :
   PanelCreate();
/*        
,  -  :*/
   if(!RevisionCreateTime(QUANT_OBJ,timeCreateObj))
     {return(REASON_INITFAILED);}
/*       
    :*/
   flagAntivandal=flagResetEventDelete=0;
//---       
   bool res=true;
   ChartEventObjectDeleteGet(res);
   if(res!=true)
     {ChartEventObjectDeleteSet(true);}
//---
   EventSetTimer(5);
//--- 
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
   flagAntivandal=-1;
   TEST_PRINT_ONE(flagAntivandal);
//---    :
   ObjectsDeleteAll(0,prefixObj,0,-1);
//---
   EventKillTimer();
//---  ,   OnInit() REASON_INITFAILED.
   if(reason==REASON_INITFAILED)
     {
      ChIndicatorDelete(prefixObj,textDelInd[0],textDelInd[1],0,0);
     }
//---
   ChartRedraw();
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const int begin,
                const double &price[])
  {
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
//| Timer function                                                   |
//+------------------------------------------------------------------+
void OnTimer()
  {
//---       
   bool res=true;
   ChartEventObjectDeleteGet(res);
   if(res!=true)
     {ChartEventObjectDeleteSet(true);}
  }
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
//+------------------------------------------------------------------+
//|                             |
//+------------------------------------------------------------------+ 
   if(id==CHARTEVENT_OBJECT_CLICK)
     {
/*       ,  
,          . 
           
    :*/
      findPrefixObject=StringFind(sparam,prefixObj);
      //---
      if(findPrefixObject==0)
        {
         string clickedChartObject=sparam;
         findPrefixObject=-1;
         //---
         for(int i=QUANT_OBJ-2;i>=0;i--)
           {
/*     ,   :*/
            if(StringCompare(clickedChartObject,nameObj[i],true)==0)
              {
               int count=0,index=-1;
               //,          :
               if(i==4|| i==1)//if "No"
                 {
                  index=1;
                  count=countClick[index]-1;
                 }
               else if(i==3 || i==0)//if "Yes"
                 {
                  index=0;
                  count=countClick[index]+1;
                 }
               else {return;}//,     
               //--- 
               int summ=countClick[NUMBER_ALL]+1;
                //---     :
               countClick[index]=count;
               countClick[NUMBER_ALL]=summ;
               //---     :
               textObj[index]=IntegerToString(count);
               textObj[NUMBER_ALL]=IntegerToString(summ);
               //---     :
               ObSetString(0,nameObj[index],OBJPROP_TEXT,textObj[index]);
               ObSetString(0,nameObj[NUMBER_ALL],OBJPROP_TEXT,textObj[NUMBER_ALL]);
               //---        :
               ChartRedraw();
               return;
              }// if(StringCompare(clickedChartObject,nameObj[i],true)==0)
           }//for(int i=QUANT_OBJ-2;i>=0;i--)
         return;
        }//if(findPrefixObject==0)
      return;
     }//if(id==CHARTEVENT_OBJECT_CLICK)
//+------------------------------------------------------------------+
//|             |
//| CHARTEVENT_OBJECT_CHANGE                                         |
//|     (       |
//|  CHART_EVENT_OBJECT_DELETE=true)                         |
//+------------------------------------------------------------------+
   else  if(id==CHARTEVENT_OBJECT_DELETE || id==CHARTEVENT_OBJECT_CHANGE)
     {
      if(flagAntivandal==-1){return;}
      else if(flagResetEventDelete>0)
        {
         findPrefixObject=StringFind(sparam,prefixObj);
         if(findPrefixObject==0)
           {
            findPrefixObject=-1;
/*  -     
        
   :*/
            flagResetEventDelete=flagResetEventDelete-1;
            //---
            TEST_PRINT_THREE(id,sparam,flagResetEventDelete);
            return;
           }
         return;
        }
      else if(flagAntivandal==0 && flagResetEventDelete==0)
        {
         //---    :
         findPrefixObject=StringFind(sparam,prefixObj);
         if(findPrefixObject==0)//    
           {
            string chartObject=sparam;//   
            findPrefixObject=-1;
            //---
            TEST_PRINT_TWO(id,sparam);
/*,    ""   ,   
             :*/
            RestoringObjArrayAll(chartObject,prefixObj,flagAntivandal,
                                 flagResetEventDelete,QUANT_OBJ,nameObj,
                                 timeCreateObj);
            return;
           }//if(findPrefixObject==0)
         return;
        }//else if(flagAntivandal==0 && flagResetEventDelete==0)
      return;
     }//else  if(id==CHARTEVENT_OBJECT_DELETE || id==CHARTEVENT_OBJECT_CHANGE)
   return;
  }//void OnChartEvent
//+------------------------------------------------------------------+
//|   ,          |
//| :                                                       |
//+------------------------------------------------------------------+
void LanguageTerminal()
  {
   string language_t=NULL;
   language_t=TerminalInfoString(TERMINAL_LANGUAGE);
//---
   if(language_t=="Russian")
     {
      textObj[3]=": ";
      textObj[4]=": ";
      textObj[5]=": ";
      //---
      textRestoring="   :  ";
      //---
      //---
      StringConcatenate(textDelInd[0],"   : \"",
                        prefixObj,"\".  : ");
      StringConcatenate(textDelInd[1],"   : \"",
                        prefixObj,"\".");
     }
   else
     {
      textObj[3]="Yes: ";
      textObj[4]="No: ";
      textObj[5]="All: ";
      //---
      textRestoring="Notification of the insured event: object ";
      //---
      StringConcatenate(textDelInd[0],"Failed to delete indicator: \"",
                        prefixObj,"\". Error code: ");
      StringConcatenate(textDelInd[1],
                        "Withdrew from chart indicator: \"",
                        prefixObj,"\".");
     }
//---
   return;
  }
//+------------------------------------------------------------------+
//|                                        |
//+------------------------------------------------------------------+
void NameObjectPanel(int quant,// 
                     string &name[],
                     const string prefix,
                     const string dt)//-
  {
   string text=NULL;
//---
   for(int x=0;x<quant;x++)
     {
      StringConcatenate(text,prefix,"_",dt,"_",IntegerToString(x));
      name[x]=text;
     }
  }
//+------------------------------------------------------------------+
//|                                           |
//+------------------------------------------------------------------+
void PanelCreate(const long chart_ID=0,const int sub_window=0)
  {
   for(int i=NUMBER_ALL;i>=0;i--)
     {
      //---     :
      if(ObjectFind(chart_ID,nameObj[i])<0)
        {
         EditCreate(chart_ID,nameObj[i],sub_window,X_DISTANCE+WIDTH,
                    Y_DISTANCE+(HEIGHT)*(i),WIDTH,HEIGHT,
                    textObj[i],"Arial",FONT_SIZE,"\n",ALIGN_RIGHT,true,
                    CORNER_PANEL,clrText[i],CLR_PANEL,CLR_BORDER);
         //---      :
         CreateTimeGet(chart_ID,nameObj[i],timeCreateObj[i]);
        }
     }
//---
   int correct=NUMBER_ALL+1;
//---
   for(int i=QUANT_OBJ-1;i>=correct;i--)
     {
      //---    :
      if(ObjectFind(chart_ID,nameObj[i])<0)
        {
         EditCreate(chart_ID,nameObj[i],sub_window,X_DISTANCE+(WIDTH*2),
                    Y_DISTANCE+(HEIGHT)*(i-correct),WIDTH,HEIGHT,
                    textObj[i],"Arial",FONT_SIZE,"\n",ALIGN_LEFT,true,
                    CORNER_PANEL,clrText[i-correct],CLR_PANEL,CLR_BORDER);
         //---      :
         CreateTimeGet(chart_ID,nameObj[i],timeCreateObj[i]);
        }
     }
   return;
  }
//+------------------------------------------------------------------+
//|                                    |
//+------------------------------------------------------------------+
bool CreateTimeGet(const long chart_ID,
                   const string &name,
                   datetime &value
                   )
  {
   datetime res=0;
   if(!ObjectGetInteger(chart_ID,name,OBJPROP_CREATETIME,0,res))
     {
      Print(LINE_NUMBER,__FUNCTION__,", Error = ",
            GetLastError(),", name: ",name);
      return(false);
     }
   value=res;
   return(true);
  }
//+------------------------------------------------------------------+
//|      :                   |
//+------------------------------------------------------------------+
bool RevisionCreateTime(int quant,datetime &time_create[])
  {
   datetime t=0;
   for(int i=quant-1;i>=0;i--)
     {
      t=time_create[i];
      if(t==0)
        {
         Print(LINE_NUMBER,__FUNCTION__,", Error create time: ",
               TimeToString(t,TIME_DATE|TIME_SECONDS));
         return(false);
        }
     }
//---
   return(true);
  }
//+------------------------------------------------------------------+
//|        |
//|  mql5-   ?                          |
//+------------------------------------------------------------------+
//|  :                                                       |
//|  MQL5 /  ,   |
//| /   /                     |
//+------------------------------------------------------------------+
bool ChartEventObjectDeleteGet(bool &result,const long chart_ID=0,
                               const int sub_window=0)
  {
//---      
   long value;
//---   
   ResetLastError();
//---   
   if(!ChartGetInteger(chart_ID,CHART_EVENT_OBJECT_DELETE,sub_window,value))
     {
      //---       ""
      Print(LINE_NUMBER,__FUNCTION__,", Error Code = ",GetLastError());
      return(false);
     }
//---      
   result=value;
//---  
   return(true);
  }
//+------------------------------------------------------------------+
//|  /         |
//|     mql5-       |
//| .                                                         |
//+------------------------------------------------------------------+
//|  MQL5 /  ,   |
//| /   /                     |
//+------------------------------------------------------------------+
bool ChartEventObjectDeleteSet(const bool value,const long chart_ID=0,
                               const int sub_window=0)
  {
//---   
   ResetLastError();
//---   
   if(!ChartSetInteger(chart_ID,CHART_EVENT_OBJECT_DELETE,sub_window,value))
     {
      //---       ""
      Print(LINE_NUMBER,__FUNCTION__,", Error Code = ",GetLastError());
      return(false);
     }
//---  
   return(true);
  }
//+-------------------------------------------------------------------+
//|  "c"   OnChartEvent()          |
//+-------------------------------------------------------------------+
//| string sparam =  ,   OnChartEvent()         |
//| string prefix_obj =                 |
//| int &flag_antivandal =   /     |
//| int &flag_reset =                                |
//| int quant_obj =     ""          |
//|                                                            |
//| string &name[] =   ""                 |
//| datetime &time_create[] =        |
//| int quant_obj_all=-1      |
//| , >= quant_obj ( -1,   quant_obj)             |
//| const long chart_ID = 0                       |
//| const int sub_window = 0                                |
//| int start_pos=0        |
//+-------------------------------------------------------------------+
int RestoringObjArrayAll(const string sparam,
                         const string prefix_obj,
                         int &flag_antivandal,
                         int &flag_reset,
                         const int quant_obj,
                         string &name[],
                         datetime &time_create[],
                         int quant_obj_all=-1,
                         const long chart_ID=0,
                         const int sub_window=0,
                         const int start_pos=0)
  {
//---   :
   int res=-1;
/*        
   .  ,        
     ,      "" 
   .
         
        .*/
   if(quant_obj<=0)//     <= 0
     {
      Print(LINE_NUMBER,__FUNCTION__,
            ", Error Code. Wrong value: quant_obj =",quant_obj);
      return(res);
     }
   else   if(quant_obj>quant_obj_all && quant_obj_all!=-1)
     {
      Print(LINE_NUMBER,__FUNCTION__,
            ", Error Code. Not the correct value: quant_obj_all");
      return(res);
     }
   else if(quant_obj_all==-1){quant_obj_all=quant_obj;}
//---       :
   int comparison=-1;
/*          
  :*/
   for(int i=quant_obj-1;i>=0;i--)
     {
      comparison=StringCompare(sparam,name[i],true);
      //---     :
      if(comparison==0)
        {
         comparison=-1;
         res=1;
         //---    "" :
         Print(LINE_NUMBER,textRestoring,sparam);
/*    ,   
     :*/
         flag_antivandal=-1;
/*  - ,    
   .    
       
    :*/
         flag_reset=quant_obj_all-1;
         //---  ,   ,   :
         ObDeletePrefixFlag(flag_reset,prefix_obj,chart_ID,sub_window,start_pos);
         //---  :
         ChartRedraw();
         //--- ,   ,  :*/
         ObDelCreateTimeExcept0(time_create[i],chart_ID,sub_window);
         //---  :
         PanelCreate();
         //---   :
         ChartRedraw();
         //---  :
         flag_antivandal=0;
         //---     for()   :
         TEST_PRINT_ONE(res);
         return(res);
        }
     }//for(int i=QUANT_OBJECTS-1;i>=0;i--)
   TEST_PRINT_ONE(res);
   return(res);
  }
//+------------------------------------------------------------------+
//|                   |
//|(  ,  ):                              |
//| 2015 ( : 09.09.2015)                           |
//+------------------------------------------------------------------+
//|   :                                            |
//| http://book.mql4.com/ru/functions/strings                        |
//| http://forum.mql4.com/ru/56236/page323#877513                    |
//| http://forum.mql4.com/ru/46980/page423#703533                    |
//+------------------------------------------------------------------+
//| int &flag_reset =            |
//| string prefix_obj =                   |
//| long  chart_ID =                             | 
//| int   sub_window=-1 =   (-1 = )                     |
//| int start_pos=-1 =       |
//|                                                     |
//+------------------------------------------------------------------+
int ObDeletePrefixFlag(int &flag_reset,
                       string prefix_obj,
                       const long chart_ID=0,
                       const int sub_window=0,
                       int start_pos=0)

  {
   int quant_obj=ObjectsTotal(chart_ID,sub_window,-1);
   if(quant_obj>0)
     {
      int count=0;
      int prefix_len=StringLen(prefix_obj);
      string find_substr=NULL,obj_name=NULL;
      //---
      for(int i=quant_obj-1;i>=0;i--)
        {
         obj_name=ObjectName(chart_ID,i,sub_window,-1);
         find_substr=StringSubstr(obj_name,start_pos,prefix_len);

         if(StringCompare(find_substr,prefix_obj,true)==0)
           {
            count=count+1;
            ObDelete(chart_ID,obj_name);
            TEST_PRINT_TWO(obj_name,count);
           }
        }
      if(count>0 && flag_reset<count)
        {flag_reset=count;}
     }
   return(flag_reset);
  }
//+------------------------------------------------------------------+
//|                               |
//|   ,  :                               |
//|(      = 0(1970.01.01 00:00:00)|
//| 2015 ( : 09.09.2015), Dina Paches              |
//| https://login.mql5.com/ru/users/dipach                           |
//+------------------------------------------------------------------+
//|      :                     |
//| http://book.mql4.com/ru/functions/strings                        |
//| http://forum.mql4.com/ru/56236/page323#877513                    |
//| http://forum.mql4.com/ru/46980/page423#703533                    |
//+------------------------------------------------------------------+
void ObDelCreateTimeExcept0(datetime &create_time,//  
                            long chart_ID=0,//  
                            int sub_window=-1,//  
                            ENUM_OBJECT type=-1)// -1 =   
  {
/*  ,    = 0(1970.01.01 00:00:00),
       ,    
 ,       
  :*/
   if(create_time==0){return;}
   int quant_obj=0;
   quant_obj=ObjectsTotal(chart_ID,sub_window,type);
//---
   if(quant_obj>0)
     {
      datetime create_time_x=0;
      string obj_name=NULL;
      //---
      for(int i=quant_obj-1;i>=0;i--)
        {
         obj_name=ObjectName(chart_ID,i,sub_window,type);
         create_time_x=(datetime)ObjectGetInteger(chart_ID,
                        obj_name,OBJPROP_CREATETIME);
         //---
         if(create_time_x==create_time)
           {ObDelete(chart_ID,obj_name);}
        }
     }
   return;
  }
//+------------------------------------------------------------------+
//|                                        |
//+------------------------------------------------------------------+
void ChIndicatorDelete(const string short_name,//  
                       const string &text_0,//     
                       const string &text_1,//   
                       const long  chart_id=0,//  
                       const int   sub_window=-1//  
                       )
  {
   bool res=ChartIndicatorDelete(chart_id,sub_window,short_name);
//---
   if(!res){Print(LINE_NUMBER,text_0,GetLastError());}
   else Print(LINE_NUMBER,text_1);
  }
//+------------------------------------------------------------------+
